﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sales
{
    public class NewOrder : IOrderState
    {
        private SalesOrder salesOrder;

        public NewOrder(SalesOrder so)
        {
            this.salesOrder = so;
        }

        public void AddOrderLine()
        {
            this.salesOrder._AddOrderLine();
        }

        public void Register()
        {
            this.salesOrder._Register();
            this.salesOrder.currentState = new Registered(this.salesOrder);
        }

        public void Grant()
        {
            throw new ChangeStateException("Not registered yet!");
        }

        public void Ship()
        {
            throw new ChangeStateException("Not registered yet!");
        }

        public void Invoice()
        {
            throw new ChangeStateException("Not registered yet!");
        }

        public void Cancel()
        {
            this.salesOrder._Cancel();
            this.salesOrder.currentState = new Canceled(this.salesOrder);
        }
    }
}
