﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sales
{
    public class Registered : IOrderState
    {
        private SalesOrder salesOrder;

        public Registered(SalesOrder salesOrder)
        {
            this.salesOrder = salesOrder;
        }
        public void AddOrderLine()
        {
            this.salesOrder._AddOrderLine();
        }

        public void Register()
        {
            throw new ChangeStateException("Already registered");
        }

        public void Grant()
        {
            this.salesOrder._Grant();
            this.salesOrder.currentState = new Granted(this.salesOrder);
        }

        public void Ship()
        {
            throw new ChangeStateException("Not granted yet!");
        }

        public void Invoice()
        {
            throw new ChangeStateException("Not granted yet!");
        }

        public void Cancel()
        {
            this.salesOrder._Cancel();
            this.salesOrder.currentState = new Canceled(this.salesOrder);
        }
    }
}
